///////////////////////////////////////////////////////////////////////////////////
// GameStudio main script
////////////////////////////////////////////////////////////////////////////
// Files to over-ride:
// * logodark.bmp - the engine logo, include your game title
// * horizon.pcx - A horizon map displayed over the sky and cloud maps
////////////////////////////////////////////////////////////////////////////
// The PATH keyword gives directories where game files can be found,
// relative to the level directory
path "C:\\Program Files\\GStudio6\\template";	// Path to WDL templates subdirectory

////////////////////////////////////////////////////////////////////////////
// The INCLUDE keyword can be used to include further WDL files,
// like those in the TEMPLATE subdirectory, with prefabricated actions

////////////////////////////////////////////////////////////////////////////
// The engine starts in the resolution given by the follwing vars.
var video_mode = 8;	 // screen size 640x480
var video_depth = 16; // 16 bit colour D3D mode

/////////////////////////////////////////////////////////////////
// Strings and filenames
// change this string to your own starting mission message.

string level_str = <roller.WMB>; // give file names in angular brackets

/////////////////////////////////////////////////////////////////
// define a splash screen with the required A4/A5 logo
bmap splashmap = <logodark.pcx>; // the default logo in templates
panel splashscreen {
	bmap = splashmap;
	flags = refresh,d3d;
}

////////////////////////////////////////////////////////////////////////////
// The following script controls the sky


/////////////////////////////////////////////////////////////////
// The main() function is started at game start
font digit_font=<digfont.pcx>,12,16;bmap rllr=<roller.bmp>;bmap rllr2=<roller2.bmp>;bmap pointmap=<gb4.bmp>;
var point;var balls; var pointballs;var phys=1; var play;FONT digit_font2=<font1_blue.pcx>,12,16;
panel intro
{bmap=rllr;
pos_y=0;pos_x=0;
}
panel end
{bmap=rllr2;
pos_y=0;pos_x=0;
digits 200,270,2,digit_font,10,point;
digits 330,270,2,digit_font,10,balls;
digits 220,320,2,digit_font2,1,pointballs;}
panel points
{bmap=pointmap;
pos_y=0;pos_x=0;
digits 10,10,2,digit_font,10,point;
flags visible,refresh;}
function main()
{SKY_CLIP=-90;
// set some common flags and variables
//	warn_level = 2;	// announce bad texture sizes and bad wdl code
	tex_share = on;	// map entities share their textures

// center the splash screen for non-640x480 resolutions, and display it
	splashscreen.pos_x = (screen_size.x - bmap_width(splashmap))/2;
	splashscreen.pos_y = (screen_size.y - bmap_height(splashmap))/2;
	splashscreen.visible = on;
// wait 3 frames (for triple buffering) until it is flipped to the foreground
	wait(3);

// now load the level
	level_load(level_str);
// freeze the game
	freeze_mode = 1;

// wait the required second, then switch the splashscreen off.
	sleep(1);
  	splashscreen.visible = off;
	bmap_purge(splashmap);	// remove splashscreen from video memory

// load some global variables, like sound volume


// display the initial message


// initialize lens flares when edition supports flares


// use the new 3rd person camera


// un-freeze the game
	freeze_mode = 0;

//	client_move();	// for a possible multiplayer game
// call further functions here...
intro.pos_x=(screen_size.x - bmap_width(rllr))/2;
intro.pos_y= (screen_size.y - bmap_height(rllr))/2;
intro.visible=on;
sleep(5);intro.visible=off;play=1;end.pos_x=(screen_size.x - bmap_width(rllr))/2;
end.pos_y= (screen_size.y - bmap_height(rllr))/2;

}


/////////////////////////////////////////////////////////////////
// The following definitions are for the pro edition window composer
// to define the start and exit window of the application.
WINDOW WINSTART
{
	TITLE			"3D GameStudio";
	SIZE			480,320;
	MODE			IMAGE;	//STANDARD;
	BG_COLOR		RGB(240,240,240);
	FRAME			FTYP1,0,0,480,320;
//	BUTTON		BUTTON_START,SYS_DEFAULT,"Start",400,288,72,24;
	BUTTON		BUTTON_QUIT,SYS_DEFAULT,"Abort",400,288,72,24;
	TEXT_STDOUT	"Arial",RGB(0,0,0),10,10,460,280;
}

/* no exit window at all..
WINDOW WINEND
{
	TITLE			"Finished";
	SIZE			540,320;
	MODE	 		STANDARD;
	BG_COLOR		RGB(0,0,0);
	TEXT_STDOUT	"",RGB(255,40,40),10,20,520,270;

	SET FONT		"",RGB(0,255,255);
	TEXT			"Any key to exit",10,270;
}*/


/////////////////////////////////////////////////////////////////
//INCLUDE <debug.wdl>;
var place[3];var place2[3];var camrot=0;var camp;entity* ballcam;
action baller
{ballcam=me;
}
function camera1
{while(1){if(camp==1){while(camera.x>my.x-100){camera.x-=1*time;camera.y = my.y; 
          camera.z = my.z + 80; vec_set(temp.x,my.x);vec_sub(temp.x,camera.x);vec_to_angle(camera.pan,temp.x);
wait(1);} camp=0;
          
          
}if(camp==0){camera.x = my.x-100; 
          camera.y = my.y; 
          camera.z = my.z + 80; vec_set(temp.x,my.x);vec_sub(temp.x,camera.x);vec_to_angle(camera.pan,temp.x);
          
}if(camp==2){camera.x = my.x-10; 
          camera.y = my.y; 
          camera.z = my.z + 80; camera.pan+vec_set(temp.x,my.x);vec_sub(temp.x,camera.x);vec_to_angle(camera.pan,temp.x);
          
}if(camp==3){camera.x = my.x-1; 
          camera.y = my.y; 
          camera.z = my.z - 80; vec_set(temp.x,my.x);vec_sub(temp.x,camera.x);vec_to_angle(camera.pan,temp.x);
          
}if(camp==4){
         camera.x=my.x+10;camera.y = my.y;camera.z = my.z ;
          
          
}if(camp==5){camera.x = my.x+80; 
          camera.y = my.y; 
          camera.z = my.z + 80; vec_set(temp.x,my.x);vec_sub(temp.x,camera.x);vec_to_angle(camera.pan,temp.x);
          
}
wait(1);}
}var d1=0;
function reset
{while(my.z>-1129){wait(1);
}phent_settype(my,0,0);my=null;level_load(level_str);d1=0;camp=0;point=0;balls=0;pointballs=0;
}
action roller
{camera1();reset();phys=1;player=me;wait(10);ballcam=me;my.enable_impact=on;my.enable_block=on;my.enable_trigger=on;my.trigger_range=10;phent_settype(my,ph_rigid,ph_sphere);phent_setmass(my,1,ph_sphere);
temp.x=0;temp.y=0;temp.z=-386;
ph_setgravity(temp);phent_setfriction(my,30);phent_setelasticity(my,0,10);
while(my!=null){if(phys==1){if(play==1){

if(key_a==1){phent_addcentralforce(my,vector(0,200,0));}
if(key_d==1){phent_addcentralforce(my,vector(0,-200,0));}
if(key_w==1){phent_addcentralforce(my,vector(200,0,0));}
if(key_s==1){phent_addcentralforce(my,vector(-200,0,0));}
}}if(phys==0){phent_settype(my,0,0);break;
}
wait(1);
}
}

function door1
{if(event_type==event_impact&&you.z>my.z+25){while(my.z>67){my.z-=.1*time;
wait(1);}
}d1=1;
}
action s1
{my.enable_impact=on;my.event=door1;
}

action gate1
{while(my.z>-32){if(d1==1){my.z-=2*time;
}wait(1);
}
}
function flipcam()
{if(event_type==event_impact){wait(100);camp=2;
}
}
action camch
{my.enable_impact=on;my.trigger_range=100;my.event=flipcam;
}
function flipcam2()
{if(event_type==event_impact){camp=1;my.enable_impact=off;
}
}
action camch2
{my.enable_impact=on;my.transparent=on;my.alpha=70;my.blue=200;my.red=1;my.green=1;my.light=on;my.trigger_range=100;my.event=flipcam2;
while(1){my.v+=5;wait(1);
}
}

function goup()
{if(event_type==event_impact){camrot=0;place2.x=ballcam.x;place2.y=ballcam.y;my.enable_impact=off;while(camrot<30){camp=0;wait(1);camrot+=.1;
phent_addcentralforce(ballcam,vector(0,0,500));}my.enable_impact=on;camp=0;}
}
action jumpup
{my.enable_impact=on;wait(10);my.event=goup;
}
action btube
{my.transparent=on;my.alpha=60;while(1){my.u+=1*time;wait(1);
}
}
function warp()
{if(event_type==event_impact){phys=0;pointballs=(point/balls)*100;
end.visible=on;
}}
bmap sparkle=<strall.pcx>;
function smoke_property() 
{my.alpha-=10*time;MY.SIZE-=2*TIME;
if (my.alpha<=00) {
	my.lifespan=0;
}}
function fire1()
{my.size=20;my.bmap=sparkle;my.move=on;my.bright=on;my.vel_z=random(10)-5;my.vel_x=random(10)-5;my.vel_y=random(10)-5;MY.RED=1;MY.GREEN=255;MY.BLUE=100;
my.flare=on;my.alpha=100;my.function=smoke_property;}
action warps
{my.enable_impact=on;wait(10);my.event=warp;while(1){effect(fire1,1,my.x,normal);wait(1);
}
}string redb2=<PART_missile_trail.PCX>;
	FUNCTION EXPLOFLARE2
{MY.PASSABLE=ON;my.oriented = off; 
my.facing = on; MY.SCALE_X=.001;MY.SCALE_Y=.001;MY.SCALE_Z=.001;VEC_TO_ANGLE(MY.PAN,NORMAL); my.alpha=100;MY.TRANSPARENT=ON;my.bright=on;MY.RED=RANDOM(255);
MY.BLUE=RANDOM(255);
MY.GREEN=RANDOM(255);MY.LIGHT=ON;my.flare=on;MY.TRANSPARENT=ON;while(MY.ALPHA >= 0)
	{
		MY.SCALE_X += 3*TIME;MY.SCALE_Y += 3*TIME;MY.SCALE_Z += 3*TIME;MY.ALPHA-=2*TIME;
		WAIT(1);
	}remove(my);}
function collect
{while(vec_dist(my.x,player.x)>30){wait(1);}media_play("bounce.wav",null,100);point+=1;my.passable=on;my.red=255;my.blue=255;my.green=255;my.light=on;ENT_CREATE(REDB2,MY.X,EXPLOFLARE2);remove(my);
}

action cllct
{balls+=1;my.passable=on;collect();
}

action cam_switcher
{camp==0;while(1){wait(1);my.passable=on;my.invisible=on;if(vec_dist(my.x,player.x)<10){camp=4;
}
}
}